



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【转载】Elasticsearch 5.x 字段折叠的使用，广度搜索</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【转载】Elasticsearch 5.x 字段折叠的使用，广度搜索</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 11:05:11 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="https://elasticsearch.cn/article/132" rel="external nofollow noreferrer">https://elasticsearch.cn/article/132</a></p>
<h3>备注，分组字段只能是 keyword或num类型，不能是text类型</h3>
<div>
<div>
<div>
	<img referrerpolicy="no-referrer"src="https://elasticsearch.cn/uploads/article/20170203/6b55278c7977e1250ac94d4f649fa663.jpg">
</div>
<p>在 Elasticsearch 5.x 有一个字段折叠（Field Collapsing，<a href="http://PR #22337" rel="external nofollow noreferrer">#22337</a>）的功能非常有意思，在这里分享一下，<br /><br />
&nbsp;<br /><br />
字段折叠是一个很有历史的需求了，可以看这个 issue，编号<a href="https://github.com/elastic/elasticsearch/issues/256" rel="external nofollow noreferrer">#256</a>，最初是2010年7月提的issue，也是讨论最多的帖子之一（240+评论），熬了6年才支持的特性，你说牛不牛，哈哈。<br /><br />
&nbsp;<br /><br />
目测该特性将于5.3发布，尝鲜地址：<a href="https://oss.sonatype.org/content/repositories/snapshots/org/elasticsearch/distribution/zip/elasticsearch/5.3.0-SNAPSHOT/" rel="external nofollow noreferrer">Elasticsearch-5.3.0-SNAPSHOT</a>，文档地址：<a href="https://www.elastic.co/guide/en/elasticsearch/reference/5.x/search-request-collapse.html" rel="external nofollow noreferrer">search-request-collapse</a>。<br /><br />
&nbsp;<br /><br />
So，什么是字段折叠，可以理解就是按特定字段进行合并去重，比如我们有一个菜谱搜索，我希望按菜谱的“菜系”字段进行折叠，即返回结果每个菜系都返回一个结果，也就是按菜系去重，我搜索关键字“鱼”，要去返回的结果里面各种菜系都有，有湘菜，有粤菜，有中餐，有西餐，别全是湘菜，就是这个意思，通过按特定字段折叠之后，来丰富搜索结果的多样性。<br /><br />
&nbsp;<br /><br />
说到这里，有人肯定会想到，使用 term agg+ top hits agg 来实现啊，这种组合两种聚和的方式可以实现上面的功能，不过也有一些局限性，比如，不能分页，<a href="https://github.com/elastic/elasticsearch/issues/4915" rel="external nofollow noreferrer">#4915</a>；结果不够精确（top term+top hits，es 的聚合实现选择了牺牲精度来提高速度）；数据量大的情况下，聚合比较慢，影响搜索体验。<br /><br />
&nbsp;<br /><br />
而新的的字段折叠的方式是怎么实现的的呢，有这些要点：</p>
<ol><li>折叠+取 inner_hits 分两阶段执行（组合聚合的方式只有一个阶段），所以 top hits 永远是精确的。</li>
<li>字段折叠只在 top hits 层执行，不需要每次都在完整的结果集上对为每个折叠主键计算实际的 doc values 值，只对 top hits 这小部分数据操作就可以，和 term agg 相比要节省很多内存。</li>
<li>因为只在 top hits 上进行折叠，所以相比组合聚合的方式，速度要快很多。</li>
<li>折叠 top docs 不需要使用全局序列（global ordinals）来转换 string，相比 agg 这也节省了很多内存。</li>
<li>分页成为可能，和常规搜索一样，具有相同的局限，先获取 from+size 的内容，再合并。</li>
<li>search_after 和 scroll 暂未实现，不过具备可行性。</li>
<li>折叠只影响搜索结果，不影响聚合，搜索结果的 total 是所有的命中纪录数，去重的结果数未知（无法计算）。</li></ol>
<p>下面来看看具体的例子，就知道怎么回事了，使用起来很简单。</p>
<ul><li>先准备索引和数据，这里以菜谱为例，name：菜谱名，type 为菜系，rating 为用户的累积平均评分</li></ul>

<pre class="prettyprint linenums"><code>DELETE recipes<br /><br />
PUT recipes<br /><br />
POST recipes/type/_mapping<br /><br />
{<br /><br />
  "properties": {<br /><br />
    "name":{<br /><br />
      "type": "text"<br /><br />
    },<br /><br />
    "rating":{<br /><br />
      "type": "float"<br /><br />
    },"type":{<br /><br />
      "type": "keyword"<br /><br />
    }<br /><br />
  }<br /><br />
}<br /><br />
POST recipes/type/<br /><br />
{<br /><br />
  "name":"清蒸鱼头","rating":1,"type":"湘菜"<br /><br />
}<br /><br />
<br /><br />
POST recipes/type/<br /><br />
{<br /><br />
  "name":"剁椒鱼头","rating":2,"type":"湘菜"<br /><br />
}<br /><br />
<br /><br />
POST recipes/type/<br /><br />
{<br /><br />
  "name":"红烧鲫鱼","rating":3,"type":"湘菜"<br /><br />
}<br /><br />
<br /><br />
POST recipes/type/<br /><br />
{<br /><br />
  "name":"鲫鱼汤（辣）","rating":3,"type":"湘菜"<br /><br />
}<br /><br />
<br /><br />
POST recipes/type/<br /><br />
{<br /><br />
  "name":"鲫鱼汤（微辣）","rating":4,"type":"湘菜"<br /><br />
}<br /><br />
<br /><br />
POST recipes/type/<br /><br />
{<br /><br />
  "name":"鲫鱼汤（变态辣）","rating":5,"type":"湘菜"<br /><br />
}<br /><br />
<br /><br />
POST recipes/type/<br /><br />
{<br /><br />
  "name":"广式鲫鱼汤","rating":5,"type":"粤菜"<br /><br />
}<br /><br />
<br /><br />
POST recipes/type/<br /><br />
{<br /><br />
  "name":"鱼香肉丝","rating":2,"type":"川菜"<br /><br />
}<br /><br />
<br /><br />
POST recipes/type/<br /><br />
{<br /><br />
  "name":"奶油鲍鱼汤","rating":2,"type":"西菜"<br /><br />
}&nbsp;</code></pre>

<ul><li>现在我们看看普通的查询效果是怎么样的，搜索关键字带“鱼”的菜，返回3条数据</li></ul>

<pre class="prettyprint linenums"><code>POST recipes/type/_search<br /><br />
{<br /><br />
  "query": {"match": {<br /><br />
    "name": "鱼"<br /><br />
  }},"size": 3<br /><br />
}&nbsp;</code></pre>
<p>全是湘菜，我的天，最近上火不想吃辣，这个第一页的结果对我来说就是垃圾，如下：
<pre class="prettyprint linenums"><code>{<br /><br />
&nbsp; "took": 2,<br /><br />
&nbsp; "timed_out": false,<br /><br />
&nbsp; "_shards": {<br /><br />
&nbsp; &nbsp; "total": 5,<br /><br />
&nbsp; &nbsp; "successful": 5,<br /><br />
&nbsp; &nbsp; "failed": 0<br /><br />
&nbsp; },<br /><br />
&nbsp; "hits": {<br /><br />
&nbsp; &nbsp; "total": 9,<br /><br />
&nbsp; &nbsp; "max_score": 0.26742277,<br /><br />
&nbsp; &nbsp; "hits": [<br /><br />
&nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_index": "recipes",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_type": "type",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_id": "AVoESHYF_OA-dG63Txsd",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_score": 0.26742277,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_source": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "name": "鲫鱼汤（变态辣）",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rating": 5,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "type": "湘菜"<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_index": "recipes",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_type": "type",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_id": "AVoESHXO_OA-dG63Txsa",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_score": 0.19100356,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_source": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "name": "红烧鲫鱼",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rating": 3,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "type": "湘菜"<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_index": "recipes",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_type": "type",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_id": "AVoESHWy_OA-dG63TxsZ",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_score": 0.19100356,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_source": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "name": "剁椒鱼头",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rating": 2,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "type": "湘菜"<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; ]<br /><br />
&nbsp; }<br /><br />
}</code></pre>
<p>我们再看看，这次我想加个评分排序，大家都喜欢的是那些，看看有没有喜欢吃的，执行查询：
<pre class="prettyprint linenums"><code>POST recipes/type/_search<br /><br />
{<br /><br />
  "query": {"match": {<br /><br />
    "name": "鱼"<br /><br />
  }},"sort": [<br /><br />
    {<br /><br />
      "rating": {<br /><br />
        "order": "desc"<br /><br />
      }<br /><br />
    }<br /><br />
  ],"size": 3<br /><br />
}&nbsp;</code></pre>
<p>结果稍微好点了，不过3个里面2个是湘菜，还是有点不合适，结果如下：
<pre class="prettyprint linenums"><code>{<br /><br />
&nbsp; "took": 1,<br /><br />
&nbsp; "timed_out": false,<br /><br />
&nbsp; "_shards": {<br /><br />
&nbsp; &nbsp; "total": 5,<br /><br />
&nbsp; &nbsp; "successful": 5,<br /><br />
&nbsp; &nbsp; "failed": 0<br /><br />
&nbsp; },<br /><br />
&nbsp; "hits": {<br /><br />
&nbsp; &nbsp; "total": 9,<br /><br />
&nbsp; &nbsp; "max_score": null,<br /><br />
&nbsp; &nbsp; "hits": [<br /><br />
&nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_index": "recipes",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_type": "type",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_id": "AVoESHYF_OA-dG63Txsd",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_source": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "name": "鲫鱼汤（变态辣）",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rating": 5,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "type": "湘菜"<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "sort": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 5<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_index": "recipes",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_type": "type",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_id": "AVoESHYW_OA-dG63Txse",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_source": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "name": "广式鲫鱼汤",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rating": 5,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "type": "粤菜"<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "sort": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 5<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_index": "recipes",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_type": "type",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_id": "AVoESHX7_OA-dG63Txsc",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_source": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "name": "鲫鱼汤（微辣）",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rating": 4,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "type": "湘菜"<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "sort": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 4<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; ]<br /><br />
&nbsp; }<br /><br />
}<br /><br />
</code></pre>
<p>现在我知道了，我要看看其他菜系，这家不是还有西餐、广东菜等各种菜系的么，来来，帮我每个菜系来一个菜看看，换 terms agg 先得到唯一的 term 的 bucket，再组合 top_hits agg，返回按评分排序的第一个 top hits，有点复杂，没关系，看下面的查询就知道了：
<pre class="prettyprint linenums"><code>GET recipes/type/_search<br /><br />
{<br /><br />
  "query": {<br /><br />
    "match": {<br /><br />
      "name": "鱼"<br /><br />
    }<br /><br />
  },<br /><br />
  "sort": [<br /><br />
    {<br /><br />
      "rating": {<br /><br />
        "order": "desc"<br /><br />
      }<br /><br />
    }<br /><br />
  ],"aggs": {<br /><br />
    "type": {<br /><br />
      "terms": {<br /><br />
        "field": "type",<br /><br />
        "size": 10<br /><br />
      },"aggs": {<br /><br />
        "rated": {<br /><br />
          "top_hits": {<br /><br />
            "sort": [{<br /><br />
              "rating": {"order": "desc"}<br /><br />
            }], <br /><br />
            "size": 1<br /><br />
          }<br /><br />
        }<br /><br />
      }<br /><br />
    }<br /><br />
  }, <br /><br />
  "size": 0,<br /><br />
  "from": 0<br /><br />
}&nbsp;</code></pre>
<p>看下面的结果，虽然 json 结构有点复杂，不过总算是我们想要的结果了，湘菜、粤菜、川菜、西菜都出来了，每样一个，不重样：
<pre class="prettyprint linenums"><code>{<br /><br />
&nbsp; "took": 4,<br /><br />
&nbsp; "timed_out": false,<br /><br />
&nbsp; "_shards": {<br /><br />
&nbsp; &nbsp; "total": 5,<br /><br />
&nbsp; &nbsp; "successful": 5,<br /><br />
&nbsp; &nbsp; "failed": 0<br /><br />
&nbsp; },<br /><br />
&nbsp; "hits": {<br /><br />
&nbsp; &nbsp; "total": 9,<br /><br />
&nbsp; &nbsp; "max_score": 0,<br /><br />
&nbsp; &nbsp; "hits": []<br /><br />
&nbsp; },<br /><br />
&nbsp; "aggregations": {<br /><br />
&nbsp; &nbsp; "type": {<br /><br />
&nbsp; &nbsp; &nbsp; "doc_count_error_upper_bound": 0,<br /><br />
&nbsp; &nbsp; &nbsp; "sum_other_doc_count": 0,<br /><br />
&nbsp; &nbsp; &nbsp; "buckets": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "key": "湘菜",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "doc_count": 6,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rated": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "hits": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "total": 6,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "max_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "hits": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_index": "recipes",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_type": "type",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_id": "AVoESHYF_OA-dG63Txsd",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_source": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "name": "鲫鱼汤（变态辣）",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rating": 5,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "type": "湘菜"<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "sort": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 5<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "key": "川菜",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "doc_count": 1,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rated": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "hits": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "total": 1,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "max_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "hits": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_index": "recipes",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_type": "type",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_id": "AVoESHYr_OA-dG63Txsf",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_source": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "name": "鱼香肉丝",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rating": 2,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "type": "川菜"<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "sort": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 2<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "key": "粤菜",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "doc_count": 1,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rated": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "hits": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "total": 1,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "max_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "hits": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_index": "recipes",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_type": "type",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_id": "AVoESHYW_OA-dG63Txse",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_source": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "name": "广式鲫鱼汤",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rating": 5,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "type": "粤菜"<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "sort": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 5<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "key": "西菜",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "doc_count": 1,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rated": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "hits": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "total": 1,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "max_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "hits": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_index": "recipes",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_type": "type",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_id": "AVoESHY3_OA-dG63Txsg",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_source": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "name": "奶油鲍鱼汤",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rating": 2,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "type": "西菜"<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "sort": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 2<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; }<br /><br />
&nbsp; }<br /><br />
}<br /><br />
</code></pre>
<p>上面的实现方法，前面已经说了，可以做，有局限性，那看看新的字段折叠法如何做到呢，查询如下，加一个 collapse 参数，指定对那个字段去重就行了，这里当然对菜系“type”字段进行去重了：
<pre class="prettyprint linenums"><code>GET recipes/type/_search<br /><br />
{<br /><br />
  "query": {<br /><br />
    "match": {<br /><br />
      "name": "鱼"<br /><br />
    }<br /><br />
  },<br /><br />
  "collapse": {<br /><br />
    "field": "type"<br /><br />
  },<br /><br />
  "size": 3,<br /><br />
  "from": 0<br /><br />
}</code></pre>
<p>结果很理想嘛，命中结果还是熟悉的那个味道（和查询结果长的一样嘛），如下：
<pre class="prettyprint linenums"><code>{<br /><br />
  "took": 1,<br /><br />
  "timed_out": false,<br /><br />
  "_shards": {<br /><br />
    "total": 5,<br /><br />
    "successful": 5,<br /><br />
    "failed": 0<br /><br />
  },<br /><br />
  "hits": {<br /><br />
    "total": 9,<br /><br />
    "max_score": null,<br /><br />
    "hits": [<br /><br />
      {<br /><br />
        "_index": "recipes",<br /><br />
        "_type": "type",<br /><br />
        "_id": "AVoDNlRJ_OA-dG63TxpW",<br /><br />
        "_score": 0.018980097,<br /><br />
        "_source": {<br /><br />
          "name": "鲫鱼汤（微辣）",<br /><br />
          "rating": 4,<br /><br />
          "type": "湘菜"<br /><br />
        },<br /><br />
        "fields": {<br /><br />
          "type": [<br /><br />
            "湘菜"<br /><br />
          ]<br /><br />
        }<br /><br />
      },<br /><br />
      {<br /><br />
        "_index": "recipes",<br /><br />
        "_type": "type",<br /><br />
        "_id": "AVoDNlRk_OA-dG63TxpZ",<br /><br />
        "_score": 0.013813315,<br /><br />
        "_source": {<br /><br />
          "name": "鱼香肉丝",<br /><br />
          "rating": 2,<br /><br />
          "type": "川菜"<br /><br />
        },<br /><br />
        "fields": {<br /><br />
          "type": [<br /><br />
            "川菜"<br /><br />
          ]<br /><br />
        }<br /><br />
      },<br /><br />
      {<br /><br />
        "_index": "recipes",<br /><br />
        "_type": "type",<br /><br />
        "_id": "AVoDNlRb_OA-dG63TxpY",<br /><br />
        "_score": 0.0125863515,<br /><br />
        "_source": {<br /><br />
          "name": "广式鲫鱼汤",<br /><br />
          "rating": 5,<br /><br />
          "type": "粤菜"<br /><br />
        },<br /><br />
        "fields": {<br /><br />
          "type": [<br /><br />
            "粤菜"<br /><br />
          ]<br /><br />
        }<br /><br />
      }<br /><br />
    ]<br /><br />
  }<br /><br />
}</code></pre>
<p>我再试试翻页，把 from 改一下，现在返回了3条数据，from 改成3，新的查询如下：
<pre class="prettyprint linenums"><code>{<br /><br />
  "took": 1,<br /><br />
  "timed_out": false,<br /><br />
  "_shards": {<br /><br />
    "total": 5,<br /><br />
    "successful": 5,<br /><br />
    "failed": 0<br /><br />
  },<br /><br />
  "hits": {<br /><br />
    "total": 9,<br /><br />
    "max_score": null,<br /><br />
    "hits": [<br /><br />
      {<br /><br />
        "_index": "recipes",<br /><br />
        "_type": "type",<br /><br />
        "_id": "AVoDNlRw_OA-dG63Txpa",<br /><br />
        "_score": 0.012546891,<br /><br />
        "_source": {<br /><br />
          "name": "奶油鲍鱼汤",<br /><br />
          "rating": 2,<br /><br />
          "type": "西菜"<br /><br />
        },<br /><br />
        "fields": {<br /><br />
          "type": [<br /><br />
            "西菜"<br /><br />
          ]<br /><br />
        }<br /><br />
      }<br /><br />
    ]<br /><br />
  }<br /><br />
}</code></pre>
<p>上面的结果只有一条了，去重之后本来就只有4条数据，上面的工作正常，每个菜系只有一个菜啊，那我不乐意了，帮我每个菜系里面多返回几条，我好选菜啊，加上参数 inner_hits 来控制返回的条数，这里返回2条，按 rating 也排个序，新的查询构造如下：
<pre class="prettyprint linenums"><code>GET recipes/type/_search<br /><br />
{<br /><br />
  "query": {<br /><br />
    "match": {<br /><br />
      "name": "鱼"<br /><br />
    }<br /><br />
  },<br /><br />
  "collapse": {<br /><br />
    "field": "type",<br /><br />
    "inner_hits": {<br /><br />
      "name": "top_rated",<br /><br />
      "size": 2,<br /><br />
      "sort": [<br /><br />
        {<br /><br />
          "rating": "desc"<br /><br />
        }<br /><br />
      ]<br /><br />
    }<br /><br />
  },<br /><br />
  "sort": [<br /><br />
    {<br /><br />
      "rating": {<br /><br />
        "order": "desc"<br /><br />
      }<br /><br />
    }<br /><br />
  ],<br /><br />
  "size": 2,<br /><br />
  "from": 0<br /><br />
}</code></pre>
<p>查询结果如下，完美：
<pre class="prettyprint linenums"><code>{<br /><br />
&nbsp; "took": 1,<br /><br />
&nbsp; "timed_out": false,<br /><br />
&nbsp; "_shards": {<br /><br />
&nbsp; &nbsp; "total": 5,<br /><br />
&nbsp; &nbsp; "successful": 5,<br /><br />
&nbsp; &nbsp; "failed": 0<br /><br />
&nbsp; },<br /><br />
&nbsp; "hits": {<br /><br />
&nbsp; &nbsp; "total": 9,<br /><br />
&nbsp; &nbsp; "max_score": null,<br /><br />
&nbsp; &nbsp; "hits": [<br /><br />
&nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_index": "recipes",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_type": "type",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_id": "AVoESHYF_OA-dG63Txsd",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_source": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "name": "鲫鱼汤（变态辣）",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rating": 5,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "type": "湘菜"<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "fields": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "type": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "湘菜"<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "sort": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 5<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; ],<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "inner_hits": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "top_rated": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "hits": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "total": 6,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "max_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "hits": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_index": "recipes",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_type": "type",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_id": "AVoESHYF_OA-dG63Txsd",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_source": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "name": "鲫鱼汤（变态辣）",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rating": 5,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "type": "湘菜"<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "sort": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 5<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_index": "recipes",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_type": "type",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_id": "AVoESHX7_OA-dG63Txsc",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_source": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "name": "鲫鱼汤（微辣）",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rating": 4,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "type": "湘菜"<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "sort": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 4<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_index": "recipes",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_type": "type",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_id": "AVoESHYW_OA-dG63Txse",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "_source": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "name": "广式鲫鱼汤",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rating": 5,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "type": "粤菜"<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "fields": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "type": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "粤菜"<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "sort": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 5<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; ],<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; "inner_hits": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "top_rated": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "hits": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "total": 1,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "max_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "hits": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_index": "recipes",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_type": "type",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_id": "AVoESHYW_OA-dG63Txse",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_score": null,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "_source": {<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "name": "广式鲫鱼汤",<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "rating": 5,<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "type": "粤菜"<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; },<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "sort": [<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 5<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ]<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; &nbsp; }<br /><br />
&nbsp; &nbsp; ]<br /><br />
&nbsp; }<br /><br />
}</code></pre>
<p>好了，字段折叠介绍就到这里。</p></div>
<pre class="prettyprint linenums"><code>                                                            &lt;div class=&quot;aw-upload-img-list&quot;&gt;<br />
                                                                                                                            &lt;/div&gt;

                                                            &lt;ul class=&quot;aw-upload-file-list&quot;&gt;<br />
                                                                                                                                        &lt;/ul&gt;

                            &lt;hr&gt;

                            &lt;div style=&quot;font-size: 12px; margin-top:10px; color: #c9cccf;&quot;&gt;<br />
                            [尊重社区原创，转载请保留或注明出处]&lt;br&gt;<br />
                            本文地址：http://elasticsearch.cn/article/132                                &lt;/div&gt;<br />
                            &lt;hr&gt;

                            &lt;div class=&quot;aw-mod aw-topic-bar&quot; style=&quot;margin: 10px 0px 0px;&quot; id=&quot;question_topic_editor&quot; data-type=&quot;article&quot; data-id=&quot;132&quot;&gt;<br />
                                &lt;div class=&quot;tag-bar clearfix&quot;&gt;<br />
                                                                                                        &lt;span class=&quot;topic-tag&quot; data-id=&quot;849&quot;&gt;

                            &lt;a class=&quot;text&quot; href=&quot;https://elasticsearch.cn/topic/5.3&quot;&gt;<br />
                                &lt;i class=&quot;icon icon-tag&quot;&gt;&lt;/i&gt;<br />
                                5.3                                &lt;/a&gt;<br />
                        &lt;/span&gt;<br />
                                                                &lt;span class=&quot;topic-tag&quot; data-id=&quot;850&quot;&gt;

                            &lt;a class=&quot;text&quot; href=&quot;https://elasticsearch.cn/topic/Field+Collapsing&quot;&gt;<br />
                                &lt;i class=&quot;icon icon-tag&quot;&gt;&lt;/i&gt;<br />
                                Field Collapsing                                &lt;/a&gt;<br />
                        &lt;/span&gt;<br />
                                                                &lt;span class=&quot;topic-tag&quot; data-id=&quot;851&quot;&gt;

                            &lt;a class=&quot;text&quot; href=&quot;https://elasticsearch.cn/topic/%E5%AD%97%E6%AE%B5%E6%8A%98%E5%8F%A0&quot;&gt;<br />
                                &lt;i class=&quot;icon icon-tag&quot;&gt;&lt;/i&gt;<br />
                                字段折叠                                &lt;/a&gt;<br />
                        &lt;/span&gt;

                                                                        &lt;/div&gt;<br />
                            &lt;/div&gt;

                            &lt;hr&gt;

                        &lt;/div&gt;</code></pre>
</div>
<div></div>
<div></div>
<div>
<div></div>
<div></div>
<div></div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7mz3kq.html">C语言中的far关键字</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mpggo8.html">windows上传代码到github</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8keprj8.html">dataguard 归档丢失&lpar;主库中无此丢失归档处理&rpar;&comma;备库基于SCN恢复</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7r71j8.html">javaweb回顾第六篇谈一谈Servlet线程安全问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyelyj9.html">ArcGIS Engine开发之旅10--空间参考及坐标转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn114038.html">Call requires API level 3 &lpar;current min is 1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd6vlmq.html">【数值方法，水题】UVa 10341 - Solve It</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydolwdq.html">oninput和onpropertychange</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w43j3q.html">C&plus;&plus; lambda 表达式传递的变量默认不可变</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ovnky9.html">C&plus;&plus;标准：C&plus;&plus;不允许修改任何基本型别&lpar;包括指针&rpar;的暂时值</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zogo1vq.html">iOS开发UI 篇&mdash;CAlayer层的属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpr6dxq.html">idea&mdash;&mdash; 模版配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p26748.html">Linux（七）开机，重启和用户登录注销</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1w1rxq.html">POJ 3294 n个串中至少一半的串共享的最长公共子串</a>
		</li>
						<li><a href="https://www.batexi.com/a/96prgwy8.html">redis 安装-配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pxdxv8.html">mac终端代理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1gnkyq.html">python3 编码解码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5d6ddq.html">java数据类型运算符类型转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllw5vkq.html">format格式化和函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5mwmeq.html">Sql语句报ORA-01795&colon; 列表中的最大表达式数为 1000</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95gwgj6q.html">re模块、hashlib模块</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rprzj9.html">拓扑排序 --- AtCode - 3596</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy4vxd9.html">&lbrack;PA2014&rsqb;Muzeum</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j12nj49.html">JS将日期转为距现在的时间长度</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j12p049.html">Android 蓝牙4&period;0 BLE &lpar;onServicesDiscovered 返回 status 是 129，133时&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1gy5lq.html">部署前准备--使用Mysql之Django Debug Toolbar安装以及配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2rkwj9.html">JS&lowbar;高程7&period;函数表达式（1）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy46v39.html">Mysql常用语句&sol;group by 和 having子句</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd5rv09.html">JSONObject、JSONArray、Map、JavaBean的相互转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4jkoj9.html">iOS 线上版本图片资源格式的问题导致的闪退</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
